import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

export const PrevPageLink = props => {
	const { disabled, onClick } = props;
	const className = classNames('p-paginator-prev p-paginator-element p-link', {
		'p-disabled': disabled,
	});

	return (
		<button
			type="button"
			className={className}
			onClick={onClick}
			disabled={disabled}
			aria-label="Poprzednia strona"
		>
			<span className="p-paginator-icon pi pi-caret-left" />
		</button>
	);
};

PrevPageLink.defaultProps = {
	disabled: false,
	onClick: null,
};

PrevPageLink.propTypes = {
	disabled: PropTypes.bool,
	onClick: PropTypes.func,
};

export default PrevPageLink;
